/*
Iza svakog parnog broja razlicitog od nula dodati sve proste djelitelje
(od najveceg prema najmanjem), te svakog ponavljamo kolika mu je kratnost.
Primjer: {3,12,5,7,-18,8,0,2,3} -> {3,12,3,2,2,5,7,-18,3,3,2,8,2,2,2,0,2,2,3}.
*/

#include <stdio.h>

void upisi_niz(int x[], int n)
{
    int i;

    for(i=0; i<n; i++){
        printf("x[%d]= ", i);
        scanf("%d", &x[i]); //x+i
    }
}

void ispis_niza(int x[], int n)
{
    int i;

    for(i=0; i<n; i++)
        printf("%d ", x[i]);
    printf("\n");
}

//FUNKCIJA VRACA NULU ZA NEPARNI BROJ I NULU
int broj_djelitelja(int x)
{
    int br=0, d=2;

    if(x%2 || x==0)
        return 0;

    x=(x>0)?x:-x;
    while(x>1){
        while(x%d==0){
            br++;
            x/=d;
        }
        d++;
    }

    return br;
}

int dodavanje(int x[], int n)
{
    int c=0, p=0, novin=0, tmp, d;

    //novin JE BROJ ELEMENATA KOJE DODAJEMO
    for(c=0; c<n; c++)
        novin+=broj_djelitelja(x[c]);

    //novin JE SAD NOVA DULJINA NIZA
    novin+=n;

    //DODAJEMO ELEMENTE U NIZ; STAVILI SMO UVJET p>c DA STANEMO
    //KAD VISE NEMA DODAVANJA (BILO BI U REDU I p>=0)
    for(p=novin-1; p>c; p--){
        if(broj_djelitelja(x[--c])){    //PROVJERAVAMO TREBAMO LI DODAVATI (TU MIJENJAMO c)
            tmp=(x[c]>0)?x[c]:-x[c];    //MORAMO DOBITI DJELITELJE PA UZIMAMO APSOLUTNU VRIJEDNOST BROJA
            d=2;
            while(tmp>1){
                while(tmp%d==0){
                    x[p--]=d;
                    tmp/=d;
                }
                d++;
            }
        }
        x[p]=x[c];
    }

    return novin;
}

int main(void)
{
    int x[100]={3,12,5,7,-18,8,0,2,3}, n=9;
    //int x[100]={1,3,5,7,9}, n=5;

    ispis_niza(x,n);
    n=dodavanje(x,n);
    ispis_niza(x,n);

    return 0;
}
