#include<stdio.h>

void upisi_niz(int x[], int n)
{
    int i;

    for(i=0; i<n; i++){
        printf("x[%d]= ", i);
        scanf("%d", &x[i]); //x+i
    }
}

//SORTIRANJE NIZA UZLAZNO PO VRIJEDNOSTI
void sort(int x[], int n)
{
    int i, j, temp;

    for(i=0; i<n; i++){
        for(j=i+1; j<n; j++){
            if(x[i]>x[j]){
                temp=x[i];
                x[i]=x[j];
                x[j]=temp;
            }
        }
    }
}

void ispis_niza(int x[], int n)
{
    int i;

    for(i=0; i<n; i++)
        printf("%d ", x[i]);
    printf("\n");
}

//BINARNO PRETRAZIVANJE (KORISTIMO DA JE NIZ SORTIRAN UZLAZNO PO VRIJEDNOSTI)
int binpret(int x[], int n, int a)
{
    int l=0, s, d=n-1;

    while(l<=d){
        s=(l+d)/2;
        if(x[s]==a)
            return s;
        if(x[s]>a)
            d=s-1;
        if(x[s]<a)
            l=s+1;
    }

    return -1;
}

int main(void)
{
    int x[1719], n;

    scanf("%d", &n);
    upisi_niz(x,n);

    sort(x,n);
    if(binpret(x,n,5)!=-1)
        printf("5 smo pronasli i na poziciji je %d.\n\n", binpret(x,n,5));
    ispis_niza(x,n);

    return 0;
}
